unit hiAdjustControls;

interface

uses Windows,Kol,Share,Debug,Win;

const
  StrParam = 'left'      + #13#10 +
             'top'       + #13#10 +
             'width'     + #13#10 +
             'height'    + #13#10 +
             'align'     + #13#10 +
             'color'     + #13#10 +
             'text'      + #13#10 +
             'caption'   + #13#10 +
             'strings'   + #13#10 +             
             'visible'   + #13#10 +
             'enabled'   + #13#10 +
             'checked'   + #13#10 +
             'selected'  + #13#10 +
             'select'    + #13#10 +
             'fontname'  + #13#10 +
             'fontcolor' + #13#10 +
             'fontsize'  + #13#10 +
             'fontstyle' + #13#10 +
             'redraw';  

  ColorValues: array [0..46] of TColor = (
    clBlack,clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGray,
    clSilver,clRed,clLime,clYellow,clBlue,clFuchsia,clAqua,clWhite,
    clMoneyGreen,clSkyBlue,clCream,clMedGray,clActiveBorder,clActiveCaption,
    clAppWorkSpace,clBackground,clBtnFace,clBtnHighlight,clBtnShadow,    
    clBtnText,clCaptionText,clDefault,clGrayText,clHighlight,clHighlightText,
    clInactiveBorder,clInactiveCaption,clInactiveCaptionText,clInfoBk,
    clInfoText,clMenu,clMenuText,clNone,clScrollBar,cl3DDkShadow,
    cl3DLight,clWindow,clWindowFrame,clWindowText );

  ColorNames: array [0..46] of String = (
    'black','maroon','green','olive','navy','purple','teal','gray',
    'silver','red','lime','yellow','blue','fuchsia','aqua','white',
    'moneygreen','skyblue','cream','medgray','activeborder','activecaption',
    'appworkspace','background','btnface','btnhighlight','btnshadow',    
    'btntext','captiontext','default','graytext','highlight','highlighttext',
    'inactiveborder','inactivecaption','inactivecaptiontext','infobk',
    'infotext','menu','menutext','none','scrollbar','3ddkshadow',
    '3dlight','window','windowframe','windowtext' );
type
  THIAdjustControls = class(TDebug)
   private
    FListSet,
    FListPar: PStrList;
    procedure SetText(const Value:string);
   public
    _data_Parameters:THI_Event;
    _event_onSet: THI_Event;
    
    constructor Create;
    destructor Destroy; override;
    function GetColor(const Value:string):integer;
    
    procedure _work_doSet(var _Data: TData; Index: word);
    property _prop_Parameters: string write SetText;
  end;
    
implementation

uses hiStr_Enum;

constructor THIAdjustControls.Create;
begin
   inherited Create;
   FListSet := NewStrList;
   FListPar := NewStrList;
   FListPar.SetText(StrParam, false);
end;

destructor THIAdjustControls.Destroy;
begin
   FListSet.Free;
   FListPar.Free;
   inherited;
end;

procedure THIAdjustControls.SetText;
begin
   FListSet.SetText(Value, false);
end;

function THIAdjustControls.GetColor;
var i: integer;
begin
   i := 0;
   while i < 46 do
    begin
     if Value = ColorNames[i] then break;
     inc(i)
    end;
   if i = 46 then Result := str2int(Value)
    else Result := ColorValues[i]; 
end;

procedure THIAdjustControls._work_doSet;
var
  tmpControl: PControl;
  i, j, val: integer;
  str, s_name, s_prop: string;

   procedure change(ind: integer);
   var
     k: integer;
   begin
     with tmpControl{$ifndef F_P}^{$endif} do
     case ind of
       0: Left := str2int(str);
       1: Top := str2int(str);
       2: Width := str2int(str);
       3: Height := str2int(str);
       4: begin
            if (str ='none')  or (str ='0') then Align := caNone   else
            if (str ='left')  or (str ='1') then Align := caLeft   else
            if (str ='top')   or (str ='2') then Align := caTop    else         
            if (str ='rigth') or (str ='3') then Align := caRight  else 
            if (str ='bottom')or (str ='4') then Align := caBottom else 
            if (str ='client')or (str ='5') then Align := caClient; 
            Invalidate;
          end;
       5: Color := GetColor(str); 
     6,7: Text := str; // text = caption
       8: begin 
           Clear;
           while str <> '' do Add(fparse(str,'|'));
          end;
       9: Visible := boolean(ord(str2int(str)));
      10: Enabled := boolean(ord(str2int(str)));
   11,12: Checked := boolean(ord(str2int(str)));
      13: begin // select -  
            val := str2int(str);
            if (val < 0) or (val >= Count) then val := -1;
            CurIndex := val;
          end;
      14: Font.FontName := str;
      15: Font.Color := GetColor(str);
      16: Font.FontHeight := str2int(str);
      17: begin
            Font.FontStyle := [];
            for k := 1 to length(str) do
            begin
              if str[k] = 'b' then Font.FontStyle := Font.FontStyle + [fsBold]
              else if str[k] = 'i' then Font.FontStyle := Font.FontStyle + [fsItalic]
              else if str[k] = 'u' then Font.FontStyle := Font.FontStyle + [fsUnderline]
              else if str[k] = 's' then Font.FontStyle := Font.FontStyle + [fsStrikeOut];
            end;
          end;
      18: if str = 'true' then InvalidateRect(Handle, nil, true);
           else InvalidateRect(Handle, nil, false);
     end;
   end;

begin
  str := ReadString(_Data, _data_Parameters);
  if str <> '' then FListSet.SetText(str, false);
  for i := 0 to ListOfControls.Count - 1 do
  begin
    tmpControl := PControl(ListOfControls.Objects[i]);
    with tmpControl{$ifndef F_P}^{$endif}  do
    if IsControl then
    begin
      for j := 0 to FListSet.Count - 1 do
      begin
        str := FListSet.Items[j];
        if str <> '' then
        begin
          s_name := LowerCase(fparse(str,'='));
          if (s_name = LowerCase(ListOfControls.Items[i])) or (s_name = 'all') then
          begin
           s_prop := LowerCase(fparse(str,'='));
           change(FListPar.IndexOf(s_prop));
          end;
        end;
      end;
    end;
  end;
  _hi_OnEvent(_event_onSet);
end;

end.